diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-phy.cc ns-3.31/src/wifi/model/wifi-phy.cc
--- ns-3.30.1/src/wifi/model/wifi-phy.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-phy.cc	2020-06-27 17:38:30.000000000 -0700
@@ -2565,333 +2585,141 @@
       NS_LOG_DEBUG ("Transmitting without power restriction");
     }
 
-  NotifyTxBegin (packet, DbmToW (GetTxPowerForTransmission (txVector) + GetTxGain ()));
-  NotifyMonitorSniffTx (packet, GetFrequency (), txVector);
-  m_state->SwitchToTx (txDuration, packet, GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
-
-  Ptr<Packet> newPacket = packet->Copy (); // obtain non-const Packet
-  WifiPhyTag oldtag;
-  newPacket->RemovePacketTag (oldtag);
   if (m_state->GetState () == WifiPhyState::OFF)
     {
       NS_LOG_DEBUG ("Transmission canceled because device is OFF");
       return;
     }
 
-  if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HT)
-    {
-      HtSigHeader htSig;
-      htSig.SetMcs (txVector.GetMode ().GetMcsValue ());
-      htSig.SetChannelWidth (txVector.GetChannelWidth ());
-      htSig.SetHtLength (packet->GetSize ());
-      htSig.SetAggregation (txVector.IsAggregation ());
-      htSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
-      newPacket->AddHeader (htSig);
-    }
-  else if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_VHT)
-    {
-      VhtSigHeader vhtSig;
-      vhtSig.SetMuFlag (txVector.GetPreambleType () == WIFI_PREAMBLE_VHT_MU);
-      vhtSig.SetChannelWidth (txVector.GetChannelWidth ());
-      vhtSig.SetShortGuardInterval (txVector.GetGuardInterval () == 400);
-      uint32_t nSymbols = (static_cast<double> ((txDuration - CalculatePlcpPreambleAndHeaderDuration (txVector)).GetNanoSeconds ()) / (3200 + txVector.GetGuardInterval ()));
-      vhtSig.SetShortGuardIntervalDisambiguation ((nSymbols % 10) == 9);
-      vhtSig.SetSuMcs (txVector.GetMode ().GetMcsValue ());
-      vhtSig.SetNStreams (txVector.GetNss ());
-      newPacket->AddHeader (vhtSig);
-    }
-  else if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HE)
-    {
-      HeSigHeader heSig;
-      heSig.SetMuFlag (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU);
-      heSig.SetMcs (txVector.GetMode ().GetMcsValue ());
-      heSig.SetBssColor (txVector.GetBssColor ());
-      heSig.SetChannelWidth (txVector.GetChannelWidth ());
-      heSig.SetGuardIntervalAndLtfSize (txVector.GetGuardInterval (), 2/*NLTF currently unused*/);
-      heSig.SetNStreams (txVector.GetNss ());
-      newPacket->AddHeader (heSig);
-    }
-  if ((txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_DSSS) || (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS))
-    {
-      DsssSigHeader sig;
-      sig.SetRate (txVector.GetMode ().GetDataRate (22));
-      Time psduDuration = txDuration - CalculatePlcpPreambleAndHeaderDuration (txVector);
-      sig.SetLength (psduDuration.GetMicroSeconds ());
-      newPacket->AddHeader (sig);
-    }
-  else if ((txVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_HT) || (txVector.GetPreambleType () != WIFI_PREAMBLE_HT_GF))
-    {
-      LSigHeader sig;
-      if ((txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_OFDM) || (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM))
-        {
-          sig.SetRate (txVector.GetMode ().GetDataRate (txVector), GetChannelWidth ());
-          sig.SetLength (packet->GetSize ());
-        }
-      else //HT, VHT or HE
-      {
-          uint8_t sigExtention = 0;
-          if (Is2_4Ghz (GetFrequency ()))
-            {
-              sigExtention = 6;
-            }
-          uint8_t m = 0;
-          if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_SU)
-            {
-              m = 2;
-            }
-          else if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
-            {
-              m = 1;
-            }
-          //Equation 27-11 of IEEE P802.11/D4.0
-          uint16_t length = ((ceil ((static_cast<double> (txDuration.GetNanoSeconds () - (20 * 1000) - (sigExtention * 1000)) / 1000) / 4.0) * 3) - 3 - m);
-          sig.SetLength (length);
-      }
-      newPacket->AddHeader (sig);
-    }
+  double txPowerW = DbmToW (GetTxPowerForTransmission (txVector) + GetTxGain ());
+  NotifyTxBegin (psdu, txPowerW);
+  m_phyTxPsduBeginTrace (psdu, txVector, txPowerW);
+  NotifyMonitorSniffTx (psdu, GetFrequency (), txVector);
+  m_state->SwitchToTx (txDuration, psdu->GetPacket (), GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
+
+  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, GetFrequency ());
 
-  uint8_t isFrameComplete = 1;
   if (m_wifiRadioEnergyModel != 0 && m_wifiRadioEnergyModel->GetMaximumTimeInState (WifiPhyState::TX) < txDuration)
     {
-      isFrameComplete = 0;
+      ppdu->SetTruncatedTx ();
     }
-  WifiPhyTag tag (txVector.GetPreambleType (), txVector.GetMode ().GetModulationClass (), isFrameComplete);
-  newPacket->AddPacketTag (tag);
 
-  StartTx (newPacket, txVector, txDuration);
+  m_endTxEvent = Simulator::Schedule (txDuration, &WifiPhy::NotifyTxEnd, this, psdu);
+
+  StartTx (ppdu);
 
   m_channelAccessRequested = false;
   m_powerRestricted = false;
 }
 
 void
-WifiPhy::StartReceiveHeader (Ptr<Event> event, Time rxDuration)
+WifiPhy::StartReceiveHeader (Ptr<Event> event)
 {
-  NS_LOG_FUNCTION (this << event->GetPacket () << event->GetTxVector () << event << rxDuration);
+  NS_LOG_FUNCTION (this << *event);
   NS_ASSERT (!IsStateRx ());
-  NS_ASSERT (m_endPlcpRxEvent.IsExpired ());
+  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
+  NS_ASSERT (m_currentEvent != 0);
+  NS_ASSERT (event->GetStartTime () == m_currentEvent->GetStartTime ());
+  NS_ASSERT (event->GetEndTime () == m_currentEvent->GetEndTime ());
 
-  InterferenceHelper::SnrPer snrPer = m_interference.CalculateLegacyPhyHeaderSnrPer (event);
+  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event);
   double snr = snrPer.snr;
   NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
 
   if (!m_preambleDetectionModel || (m_preambleDetectionModel->IsPreambleDetected (event->GetRxPowerW (), snr, m_channelWidth)))
     {
-      m_state->SwitchToRx (rxDuration);
-      NotifyRxBegin (event->GetPacket ());
+      NotifyRxBegin (event->GetPsdu ());
 
       m_timeLastPreambleDetected = Simulator::Now ();
-
       WifiTxVector txVector = event->GetTxVector ();
 
-      if (txVector.GetNss () > GetMaxSupportedRxSpatialStreams ())
-        {
-          NS_LOG_DEBUG ("Packet reception could not be started because not enough RX antennas");
-          NotifyRxDrop (event->GetPacket (), UNSUPPORTED_SETTINGS);
-          MaybeCcaBusyDuration ();
-          return;
-        }
-
       if ((txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HT) && (txVector.GetPreambleType () == WIFI_PREAMBLE_HT_GF))
         {
-          //No legacy PHY header for HT GF
-          Time remainingPreambleHeaderDuration = CalculatePlcpPreambleAndHeaderDuration (txVector) - GetPreambleDetectionDuration ();
-          m_endPlcpRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
+          //No non-HT PHY header for HT GF
+          Time remainingPreambleHeaderDuration = CalculatePhyPreambleAndHeaderDuration (txVector) - GetPreambleDetectionDuration ();
+          m_state->SwitchMaybeToCcaBusy (remainingPreambleHeaderDuration);
+          m_endPhyRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
         }
       else
         {
-          //Schedule end of legacy PHY header
-          Time remainingPreambleAndLegacyHeaderDuration = GetPlcpPreambleDuration (txVector) + GetPlcpHeaderDuration (txVector) - GetPreambleDetectionDuration ();
-          m_endPlcpRxEvent = Simulator::Schedule (remainingPreambleAndLegacyHeaderDuration, &WifiPhy::ContinueReceiveHeader, this, event);
+          //Schedule end of non-HT PHY header
+          Time remainingPreambleAndNonHtHeaderDuration = GetPhyPreambleDuration (txVector) + GetPhyHeaderDuration (txVector) - GetPreambleDetectionDuration ();
+          m_state->SwitchMaybeToCcaBusy (remainingPreambleAndNonHtHeaderDuration);
+          m_endPhyRxEvent = Simulator::Schedule (remainingPreambleAndNonHtHeaderDuration, &WifiPhy::ContinueReceiveHeader, this, event);
         }
     }
   else
     {
       NS_LOG_DEBUG ("Drop packet because PHY preamble detection failed");
-      NotifyRxDrop (event->GetPacket (), PREAMBLE_DETECT_FAILURE);
+      NotifyRxDrop (event->GetPsdu (), PREAMBLE_DETECT_FAILURE);
       m_interference.NotifyRxEnd ();
+      m_currentEvent = 0;
+
+      // Like CCA-SD, CCA-ED is governed by the 4Î¼s CCA window to flag CCA-BUSY
+      // for any received signal greater than the CCA-ED threshold.
+      if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          MaybeCcaBusyDuration ();
+        }
     }
-  // Like CCA-SD, CCA-ED is governed by the 4Î¼s CCA window to flag CCA-BUSY
-  // for any received signal greater than the CCA-ED threshold.
-  MaybeCcaBusyDuration ();
 }
 
 void
 WifiPhy::ContinueReceiveHeader (Ptr<Event> event)
 {
-  NS_LOG_FUNCTION (this << event->GetPacket () << event->GetTxVector () << event);
-  NS_ASSERT (IsStateRx ());
-  NS_ASSERT (m_endPlcpRxEvent.IsExpired ());
+  NS_LOG_FUNCTION (this << *event);
+  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
 
   InterferenceHelper::SnrPer snrPer;
-  snrPer = m_interference.CalculateLegacyPhyHeaderSnrPer (event);
+  snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event);
 
-  if (m_random->GetValue () > snrPer.per) //legacy PHY header reception succeeded
+  if (m_random->GetValue () > snrPer.per) //non-HT PHY header reception succeeded
     {
-      NS_LOG_DEBUG ("Received legacy PHY header");
+      NS_LOG_DEBUG ("Received non-HT PHY header");
       WifiTxVector txVector = event->GetTxVector ();
-      Time remainingPreambleHeaderDuration = CalculatePlcpPreambleAndHeaderDuration (txVector) - GetPlcpPreambleDuration (txVector) - GetPlcpHeaderDuration (txVector);
-      m_endPlcpRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
+      Time remainingRxDuration = event->GetEndTime () - Simulator::Now ();
+      m_state->SwitchMaybeToCcaBusy (remainingRxDuration);
+      Time remainingPreambleHeaderDuration = CalculatePhyPreambleAndHeaderDuration (txVector) - GetPhyPreambleDuration (txVector) - GetPhyHeaderDuration (txVector);
+      m_endPhyRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
     }
-  else //legacy PHY header reception failed
+  else //non-HT PHY header reception failed
     {
-      NS_LOG_DEBUG ("Abort reception because legacy PHY header reception failed");
+      NS_LOG_DEBUG ("Abort reception because non-HT PHY header reception failed");
       AbortCurrentReception (L_SIG_FAILURE);
+      if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          MaybeCcaBusyDuration ();
+        }
     }
 }
 
 void
-WifiPhy::StartReceivePreamble (Ptr<Packet> packet, double rxPowerW, Time rxDuration)
+WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, double rxPowerW)
 {
-  NS_LOG_FUNCTION (this << packet << rxPowerW << rxDuration);
-  WifiPhyTag tag;
-  bool found = packet->RemovePacketTag (tag);
-  if (!found)
-    {
-      NS_FATAL_ERROR ("Received Wi-Fi Signal with no WifiPhyTag");
-      return;
-    }
-
-  WifiPreamble preamble = tag.GetPreambleType ();
-  WifiModulationClass modulation = tag.GetModulation ();
-  WifiTxVector txVector;
-  txVector.SetPreambleType (preamble);
-  if ((modulation == WIFI_MOD_CLASS_DSSS) || (modulation == WIFI_MOD_CLASS_HR_DSSS))
-    {
-      DsssSigHeader dsssSigHdr;
-      found = packet->RemoveHeader (dsssSigHdr);
-      if (!found)
-        {
-          NS_FATAL_ERROR ("Received 802.11b signal with no SIG field");
-          return;
-        }
-      txVector.SetChannelWidth (22);
-      for (uint8_t i = 0; i < GetNModes (); i++)
-        {
-          WifiMode mode = GetMode (i);
-          if (((mode.GetModulationClass() == WIFI_MOD_CLASS_DSSS) || (mode.GetModulationClass() == WIFI_MOD_CLASS_HR_DSSS))
-              && (mode.GetDataRate (22) == dsssSigHdr.GetRate ()))
-            {
-              txVector.SetMode (mode);
-              break;
-            }
-        }
-    }
-  else if ((modulation != WIFI_MOD_CLASS_HT) || (preamble != WIFI_PREAMBLE_HT_GF))
-    {
-      LSigHeader lSigHdr;
-      found = packet->RemoveHeader (lSigHdr);
-      if (!found)
-        {
-          NS_FATAL_ERROR ("Received OFDM 802.11 signal with no SIG field");
-          return;
-        }
-      uint16_t channelWidth = GetChannelWidth ();
-      txVector.SetChannelWidth (channelWidth > 20 ? 20 : channelWidth);
-      for (uint8_t i = 0; i < GetNModes (); i++)
-        {
-          WifiMode mode = GetMode (i);
-          if (mode.GetDataRate (GetChannelWidth ()) == lSigHdr.GetRate (GetChannelWidth ()))
-            {
-              txVector.SetMode (mode);
-              break;
-            }
-        }
-    }
-  if (modulation == WIFI_MOD_CLASS_HT)
-    {
-      HtSigHeader htSigHdr;
-      found = packet->RemoveHeader (htSigHdr);
-      if (!found)
-        {
-          NS_FATAL_ERROR ("Received 802.11n signal with no HT-SIG field");
-          return;
-        }
-      txVector.SetChannelWidth (htSigHdr.GetChannelWidth ());
-      for (uint8_t i = 0; i < GetNMcs (); i++)
-        {
-          WifiMode mode = GetMcs (i);
-          if ((mode.GetModulationClass () == WIFI_MOD_CLASS_HT) && (mode.GetMcsValue () == htSigHdr.GetMcs ()))
-            {
-              txVector.SetMode (mode);
-              txVector.SetNss (1 + (txVector.GetMode ().GetMcsValue () / 8));
-              break;
-            }
-        }
-      txVector.SetGuardInterval(htSigHdr.GetShortGuardInterval () ? 400 : 800);
-      txVector.SetAggregation (htSigHdr.GetAggregation ());
-    }
-  else if (modulation == WIFI_MOD_CLASS_VHT)
-    {
-      VhtSigHeader vhtSigHdr;
-      vhtSigHdr.SetMuFlag (preamble == WIFI_PREAMBLE_VHT_MU);
-      found = packet->RemoveHeader (vhtSigHdr);
-      if (!found)
-        {
-          NS_FATAL_ERROR ("Received 802.11ac signal with no VHT-SIG field");
-          return;
-        }
-      txVector.SetChannelWidth (vhtSigHdr.GetChannelWidth ());
-      txVector.SetNss (vhtSigHdr.GetNStreams ());
-      for (uint8_t i = 0; i < GetNMcs (); i++)
-        {
-          WifiMode mode = GetMcs (i);
-          if ((mode.GetModulationClass () == WIFI_MOD_CLASS_VHT) && (mode.GetMcsValue () == vhtSigHdr.GetSuMcs ()))
-            {
-              txVector.SetMode (mode);
-              break;
-            }
-        }
-      txVector.SetGuardInterval (vhtSigHdr.GetShortGuardInterval () ? 400 : 800);
-      if (IsAmpdu (packet))
-        {
-          txVector.SetAggregation (true);
-        }
-    }
-  else if (modulation == WIFI_MOD_CLASS_HE)
-    {
-      HeSigHeader heSigHdr;
-      heSigHdr.SetMuFlag (preamble == WIFI_PREAMBLE_HE_MU);
-      found = packet->RemoveHeader (heSigHdr);
-      if (!found)
-        {
-          NS_FATAL_ERROR ("Received 802.11ax signal with no HE-SIG field");
-          return;
-        }
-      txVector.SetChannelWidth (heSigHdr.GetChannelWidth ());
-      txVector.SetNss (heSigHdr.GetNStreams ());
-      for (uint8_t i = 0; i < GetNMcs (); i++)
-        {
-          WifiMode mode = GetMcs (i);
-          if ((mode.GetModulationClass () == WIFI_MOD_CLASS_HE) && (mode.GetMcsValue () == heSigHdr.GetMcs ()))
-            {
-              txVector.SetMode (mode);
-              break;
-            }
-        }
-      txVector.SetGuardInterval (heSigHdr.GetGuardInterval ());
-      txVector.SetBssColor (heSigHdr.GetBssColor ());
-      if (IsAmpdu (packet))
-        {
-          txVector.SetAggregation (true);
-        }
-    }
-
-  Ptr<Event> event;
-  event = m_interference.Add (packet,
-                              txVector,
-                              rxDuration,
-                              rxPowerW);
+  NS_LOG_FUNCTION (this << *ppdu << rxPowerW);
+  WifiTxVector txVector = ppdu->GetTxVector ();
+  Time rxDuration = ppdu->GetTxDuration ();
+  Ptr<const WifiPsdu> psdu = ppdu->GetPsdu ();
+  Ptr<Event> event = m_interference.Add (ppdu, txVector, rxDuration, rxPowerW);
+  Time endRx = Simulator::Now () + rxDuration;
 
   if (m_state->GetState () == WifiPhyState::OFF)
     {
       NS_LOG_DEBUG ("Cannot start RX because device is OFF");
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          MaybeCcaBusyDuration ();
+        }
       return;
     }
 
-  if (tag.GetFrameComplete () == 0)
+  if (ppdu->IsTruncatedTx ())
     {
       NS_LOG_DEBUG ("Packet reception stopped because transmitter has been switched off");
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          MaybeCcaBusyDuration ();
+        }
       return;
     }
 
@@ -2899,29 +2727,31 @@
     {
       //If SetRate method was not called above when filling in txVector, this means the PHY does support the rate indicated in PHY SIG headers
       NS_LOG_DEBUG ("drop packet because of unsupported RX mode");
-      NotifyRxDrop (packet, UNSUPPORTED_SETTINGS);
+      NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          MaybeCcaBusyDuration ();
+        }
       return;
     }
 
-  Time endRx = Simulator::Now () + rxDuration;
   switch (m_state->GetState ())
     {
     case WifiPhyState::SWITCHING:
       NS_LOG_DEBUG ("drop packet because of channel switching");
-      NotifyRxDrop (packet, NOT_ALLOWED);
+      NotifyRxDrop (psdu, CHANNEL_SWITCHING);
       /*
        * Packets received on the upcoming channel are added to the event list
        * during the switching state. This way the medium can be correctly sensed
        * when the device listens to the channel for the first time after the
        * switching e.g. after channel switching, the channel may be sensed as
-       * busy due to other devices' tramissions started before the end of
+       * busy due to other devices' transmissions started before the end of
        * the switching.
        */
-      if (endRx > Simulator::Now () + m_state->GetDelayUntilIdle ())
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
           //that packet will be noise _after_ the completion of the channel switching.
           MaybeCcaBusyDuration ();
-          return;
         }
       break;
     case WifiPhyState::RX:
@@ -2932,39 +2762,69 @@
         {
           AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
           NS_LOG_DEBUG ("Switch to new packet");
-          StartRx (event, rxPowerW, rxDuration);
+          StartRx (event, rxPowerW);
         }
       else
         {
           NS_LOG_DEBUG ("Drop packet because already in Rx (power=" <<
                         rxPowerW << "W)");
-          NotifyRxDrop (packet, NOT_ALLOWED);
-          if (endRx > Simulator::Now () + m_state->GetDelayUntilIdle ())
+          NotifyRxDrop (psdu, RXING);
+          if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
             {
               //that packet will be noise _after_ the reception of the currently-received packet.
               MaybeCcaBusyDuration ();
-              return;
             }
         }
       break;
     case WifiPhyState::TX:
       NS_LOG_DEBUG ("Drop packet because already in Tx (power=" <<
                     rxPowerW << "W)");
-      NotifyRxDrop (packet, NOT_ALLOWED);
-      if (endRx > Simulator::Now () + m_state->GetDelayUntilIdle ())
+      NotifyRxDrop (psdu, TXING);
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
           //that packet will be noise _after_ the transmission of the currently-transmitted packet.
           MaybeCcaBusyDuration ();
-          return;
         }
       break;
     case WifiPhyState::CCA_BUSY:
+      if (m_currentEvent != 0)
+        {
+          if (m_frameCaptureModel != 0
+              && m_frameCaptureModel->IsInCaptureWindow (m_timeLastPreambleDetected)
+              && m_frameCaptureModel->CaptureNewFrame (m_currentEvent, event))
+            {
+              AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
+              NS_LOG_DEBUG ("Switch to new packet");
+              StartRx (event, rxPowerW);
+            }
+          else
+            {
+              NS_LOG_DEBUG ("Drop packet because already in Rx (power=" <<
+                            rxPowerW << "W)");
+              NotifyRxDrop (psdu, RXING);
+              if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+                {
+                  //that packet will be noise _after_ the reception of the currently-received packet.
+                  MaybeCcaBusyDuration ();
+                }
+            }
+        }
+      else
+        {
+          StartRx (event, rxPowerW);
+        }
+      break;
     case WifiPhyState::IDLE:
-      StartRx (event, rxPowerW, rxDuration);
+      StartRx (event, rxPowerW);
       break;
     case WifiPhyState::SLEEP:
       NS_LOG_DEBUG ("Drop packet because in sleep mode");
-      NotifyRxDrop (packet, NOT_ALLOWED);
+      NotifyRxDrop (psdu, SLEEPING);
+      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+        {
+          //that packet will be noise _after_ the sleep period.
+          MaybeCcaBusyDuration ();
+        }
       break;
     default:
       NS_FATAL_ERROR ("Invalid WifiPhy state.");
@@ -2990,31 +2850,48 @@
 void
 WifiPhy::StartReceivePayload (Ptr<Event> event)
 {
-  NS_LOG_FUNCTION (this << event->GetPacket () << event->GetTxVector ());
-  NS_ASSERT (IsStateRx ());
-  NS_ASSERT (m_endPlcpRxEvent.IsExpired ());
+  NS_LOG_FUNCTION (this << *event);
+  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
   NS_ASSERT (m_endRxEvent.IsExpired ());
   WifiTxVector txVector = event->GetTxVector ();
   WifiMode txMode = txVector.GetMode ();
   bool canReceivePayload;
-  if ((txMode.GetModulationClass () == WIFI_MOD_CLASS_HT) || (txMode.GetModulationClass () == WIFI_MOD_CLASS_VHT) || (txMode.GetModulationClass () == WIFI_MOD_CLASS_HE))
+  if (txMode.GetModulationClass () >= WIFI_MOD_CLASS_HT)
     {
       InterferenceHelper::SnrPer snrPer;
-      snrPer = m_interference.CalculateNonLegacyPhyHeaderSnrPer (event);
+      snrPer = m_interference.CalculateHtPhyHeaderSnrPer (event);
+      NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
       canReceivePayload = (m_random->GetValue () > snrPer.per);
     }
   else
     {
-      //If we are here, this means legacy PHY header was already successfully received
+      //If we are here, this means non-HT PHY header was already successfully received
       canReceivePayload = true;
     }
-  if (canReceivePayload) //plcp reception succeeded
+  Time payloadDuration = event->GetEndTime () - event->GetStartTime () - CalculatePhyPreambleAndHeaderDuration (txVector);
+  if (canReceivePayload) //PHY reception succeeded
     {
-      if (IsModeSupported (txMode) || IsMcsSupported (txMode))
+      if (txVector.GetNss () > GetMaxSupportedRxSpatialStreams ())
         {
-          Time payloadDuration = event->GetEndTime () - event->GetStartTime () - CalculatePlcpPreambleAndHeaderDuration (txVector);
+          NS_LOG_DEBUG ("Packet reception could not be started because not enough RX antennas");
+          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+        }
+      else if ((txVector.GetChannelWidth () >= 40) && (txVector.GetChannelWidth () > GetChannelWidth ()))
+        {
+          NS_LOG_DEBUG ("Packet reception could not be started because not enough channel width");
+          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+        }
+      else if (!IsModeSupported (txMode) && !IsMcsSupported (txMode))
+        {
+          NS_LOG_DEBUG ("Drop packet because it was sent using an unsupported mode (" << txMode << ")");
+          NotifyRxDrop (event->GetPsdu (), UNSUPPORTED_SETTINGS);
+        }
+      else
+        {
+          m_state->SwitchToRx (payloadDuration);
           m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::EndReceive, this, event);
-          NS_LOG_DEBUG ("Receiving payload");
+          NS_LOG_DEBUG ("Receiving PSDU");
+          m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is triggered only if headers have been correctly decoded and that the mode within is supported
           if (txMode.GetModulationClass () == WIFI_MOD_CLASS_HE)
             {
               HePreambleParameters params;
@@ -3022,96 +2899,101 @@
               params.bssColor = event->GetTxVector ().GetBssColor ();
               NotifyEndOfHePreamble (params);
             }
-        }
-      else //mode is not allowed
-        {
-          NS_LOG_DEBUG ("Drop packet because it was sent using an unsupported mode (" << txMode << ")");
-          NotifyRxDrop (event->GetPacket (), UNSUPPORTED_SETTINGS);
+          return;
         }
     }
-  else //plcp reception failed
+  else //PHY reception failed
     {
-      NS_LOG_DEBUG ("Drop packet because non-legacy PHY header reception failed");
-      NotifyRxDrop (event->GetPacket (), SIG_A_FAILURE);
+      NS_LOG_DEBUG ("Drop packet because HT PHY header reception failed");
+      NotifyRxDrop (event->GetPsdu (), SIG_A_FAILURE);
     }
+  m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::ResetReceive, this, event);
 }
 
 void
 WifiPhy::EndReceive (Ptr<Event> event)
 {
   Time psduDuration = event->GetEndTime () - event->GetStartTime ();
-  NS_LOG_FUNCTION (this << event->GetPacket () << event->GetTxVector () << event << psduDuration);
+  NS_LOG_FUNCTION (this << *event << psduDuration);
+  NS_ASSERT (GetLastRxEndTime () == Simulator::Now ());
   NS_ASSERT (event->GetEndTime () == Simulator::Now ());
 
   double snr = m_interference.CalculateSnr (event);
   std::vector<bool> statusPerMpdu;
   SignalNoiseDbm signalNoise;
 
-  Ptr<const Packet> packet = event->GetPacket ();
+  Ptr<const WifiPsdu> psdu = event->GetPsdu ();
   Time relativeStart = NanoSeconds (0);
-  bool receptionOkAtLeastForOneMpdu = true;
+  bool receptionOkAtLeastForOneMpdu = false;
   std::pair<bool, SignalNoiseDbm> rxInfo;
   WifiTxVector txVector = event->GetTxVector ();
-  if (txVector.IsAggregation ())
+  size_t nMpdus = psdu->GetNMpdus ();
+  if (nMpdus > 1)
     {
       //Extract all MPDUs of the A-MPDU to compute per-MPDU PER stats
-      //TODO remove PLCP header first
-      std::list<Ptr<const Packet>> ampduSubframes = MpduAggregator::PeekAmpduSubframes (packet);
-      size_t nbOfRemainingMpdus = ampduSubframes.size ();
-      Time remainingAmpduDuration = event->GetEndTime () - event->GetStartTime ();
-      MpduType mpdutype = (nbOfRemainingMpdus == 1) ? SINGLE_MPDU : FIRST_MPDU_IN_AGGREGATE;
-      for (const auto & subframe : ampduSubframes)
+      Time remainingAmpduDuration = psduDuration;
+      MpduType mpdutype = FIRST_MPDU_IN_AGGREGATE;
+      auto mpdu = psdu->begin ();
+      uint32_t totalAmpduSize = 0;
+      double totalAmpduNumSymbols = 0.0;
+      for (size_t i = 0; i < nMpdus && mpdu != psdu->end (); ++mpdu)
         {
-          Time mpduDuration = GetPayloadDuration (subframe->GetSize (), txVector, GetFrequency (), mpdutype, 1);
+          Time mpduDuration = GetPayloadDuration (psdu->GetAmpduSubframeSize (i), txVector,
+                                                  GetFrequency (), mpdutype, true, totalAmpduSize, totalAmpduNumSymbols);
           remainingAmpduDuration -= mpduDuration;
-          --nbOfRemainingMpdus;
-          if (nbOfRemainingMpdus == 0 && !remainingAmpduDuration.IsZero ()) //no more MPDU coming
+          if (i == (nMpdus - 1) && !remainingAmpduDuration.IsZero ()) //no more MPDU coming
             {
               mpduDuration += remainingAmpduDuration; //apply a correction just in case rounding had induced slight shift
             }
-          rxInfo = GetReceptionStatus (MpduAggregator::PeekMpduInAmpduSubframe (subframe), event, relativeStart, mpduDuration);
-          NS_LOG_DEBUG ("Extracted MPDU #" << ampduSubframes.size () - nbOfRemainingMpdus - 1 << ": duration: " << mpduDuration.GetNanoSeconds () << "ns" <<
+          rxInfo = GetReceptionStatus (Create<WifiPsdu> (*mpdu, false),
+                                       event, relativeStart, mpduDuration);
+          NS_LOG_DEBUG ("Extracted MPDU #" << i << ": duration: " << mpduDuration.GetNanoSeconds () << "ns" <<
                         ", correct reception: " << rxInfo.first <<
                         ", Signal/Noise: " << rxInfo.second.signal << "/" << rxInfo.second.noise << "dBm");
           signalNoise = rxInfo.second; //same information for all MPDUs
           statusPerMpdu.push_back (rxInfo.first);
           receptionOkAtLeastForOneMpdu |= rxInfo.first;
+
+          //Prepare next iteration
+          ++i;
           relativeStart += mpduDuration;
-          mpdutype = (nbOfRemainingMpdus == 1) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
+          mpdutype = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
         }
     }
   else
     {
-      //Simple MPDU
-      rxInfo = GetReceptionStatus (packet, event, relativeStart, psduDuration);
+      rxInfo = GetReceptionStatus (psdu, event, relativeStart, psduDuration);
       signalNoise = rxInfo.second; //same information for all MPDUs
       statusPerMpdu.push_back (rxInfo.first);
       receptionOkAtLeastForOneMpdu = rxInfo.first;
     }
 
+  NotifyRxEnd (psdu);
+
   if (receptionOkAtLeastForOneMpdu)
     {
-      NotifyMonitorSniffRx (packet, GetFrequency (), txVector, signalNoise, statusPerMpdu);
-      m_state->SwitchFromRxEndOk (packet->Copy (), snr, txVector, statusPerMpdu);
+      NotifyMonitorSniffRx (psdu, GetFrequency (), txVector, signalNoise, statusPerMpdu);
+      m_state->SwitchFromRxEndOk (Copy (psdu), snr, txVector, statusPerMpdu);
     }
   else
     {
-      m_state->SwitchFromRxEndError (packet->Copy (), snr);
+      m_state->SwitchFromRxEndError (Copy (psdu), snr);
     }
 
   m_interference.NotifyRxEnd ();
   m_currentEvent = 0;
+  MaybeCcaBusyDuration ();
 }
 
 std::pair<bool, SignalNoiseDbm>
-WifiPhy::GetReceptionStatus (Ptr<const Packet> mpdu, Ptr<Event> event, Time relativeMpduStart, Time mpduDuration)
+WifiPhy::GetReceptionStatus (Ptr<const WifiPsdu> psdu, Ptr<Event> event, Time relativeMpduStart, Time mpduDuration)
 {
-  NS_LOG_FUNCTION (this << mpdu << event->GetTxVector () << event << relativeMpduStart << mpduDuration);
+  NS_LOG_FUNCTION (this << *psdu << *event << relativeMpduStart << mpduDuration);
   InterferenceHelper::SnrPer snrPer;
   snrPer = m_interference.CalculatePayloadSnrPer (event, std::make_pair (relativeMpduStart, relativeMpduStart + mpduDuration));
 
   NS_LOG_DEBUG ("mode=" << (event->GetTxVector ().GetMode ().GetDataRate (event->GetTxVector ())) <<
-                ", snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per << ", size=" << mpdu->GetSize () <<
+                ", snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per << ", size=" << psdu->GetSize () <<
                 ", relativeStart = " << relativeMpduStart.GetNanoSeconds () << "ns, duration = " << mpduDuration.GetNanoSeconds () << "ns");
 
   // There are two error checks: PER and receive error model check.
